﻿using Infragistics.Win;
using Infragistics.Win.UltraWinListView;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraListViewDoubleClick
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.ultraListView1.Groups.Add("Group1");
            this.ultraListView1.Groups.Add("Group2");
            this.ultraListView1.Groups.Add("Group3");
            this.ultraListView1.Groups.Add("Group4");

            this.ultraListView1.BeginUpdate();

            for (int i = 0; i < 100; i++)
            {
                UltraListViewItem item = this.ultraListView1.Items.Add(null, string.Format("Item {0}", i));
                item.Group = this.ultraListView1.Groups[i / 25];
            }

            this.ultraListView1.EndUpdate();
            this.ultraListView1.MouseDoubleClick += UltraListView1_MouseDoubleClick;
            this.ultraListView1.View = UltraListViewStyle.Details;
            this.ultraListView1.ViewSettingsDetails.CheckBoxStyle = CheckBoxStyle.CheckBox;

            MyCreationFilter filter = new MyCreationFilter();
            this.ultraListView1.CreationFilter = filter;
            filter.Clicked += Filter_Clicked;

            

            this.ultraListView1.MainColumn.Text = "Header";
        }

        private void Filter_Clicked(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            SetStyle(ControlStyles.StandardClick | ControlStyles.StandardDoubleClick, true);

            CheckBoxUIElement checkBox = e.Element as CheckBoxUIElement;
            if (checkBox == null)
            {
                return;
            }

            foreach (var item in this.ultraListView1.Items)
            {
                item.CheckState = checkBox.CheckState;
            }
        }

        private void UltraListView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {

        }
    }

    public class MyCreationFilter : IUIElementCreationFilter
    {
        private CheckBoxUIElement checkBox;

        public delegate void HeaderCheckBoxClickedHandler(object sender, UIElementEventArgs e);

        public event HeaderCheckBoxClickedHandler Clicked;

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is UltraListViewColumnHeaderUIElement)
            {
                UltraListViewColumnBase column = ((UltraListViewColumnHeaderUIElement)parent).Column;
                if (column != null && column.Text == "Header")
                {
                    if (this.checkBox == null)
                    {
                        this.checkBox = new CheckBoxUIElement(parent);
                    }

                    this.checkBox.ElementClick += this.CheckBox_ElementClick;
                    parent.ChildElements.Add(this.checkBox);
                    this.checkBox.Rect = new Rectangle(parent.Rect.X + 3, parent.Rect.Y + 3, this.checkBox.CheckSize.Width, this.checkBox.CheckSize.Height);

                    TextUIElement columnHeader = (TextUIElement)parent.GetDescendant(typeof(TextUIElement));
                    columnHeader.Rect = new Rectangle(columnHeader.Rect.X + this.checkBox.Rect.Width + 3, columnHeader.Rect.Y, columnHeader.Rect.Width, columnHeader.Rect.Height);
                }
            }
        }

        public void CheckBox_ElementClick(object sender, UIElementEventArgs e)
        {
            if (this.Clicked != null)
            {
                this.Clicked.Invoke(sender, e);
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
